# makefile for secenarios

# -- directories concerning libraries and include files
ROOT =		//10/hard/xyan/work/th/2.0
SRCDIR =	$(ROOT)/src
OBJDIR=		$(ROOT)/obj
LIBDIR =	$(ROOT)/lib
INCDIR =	$(ROOT)/inc

OBJS =	$(OBJDIR)/pthread.o \
		$(OBJDIR)/cond.o \
		$(OBJDIR)/mutex.o \
		$(OBJDIR)/sched.o \
		$(OBJDIR)/queue.o 

INCS = $(INCDIR)/pthread.h $(INCDIR)/pthread/internals.h $(INCDIR)/pthread/mutex.h $(INCDIR)/pthread/stack.h 

# -- Current libraries 
MTLLIB =		$(LIBDIR)/pthread.lib

# compile and link flags
CFLAGS +=	-g -3

.c.o:
	$(COMPILE.c) -I$(INCDIR) -o $@ $<

$(MTLLIB): $(OBJS)
	wlib $@ `echo $?|awk '{for(i=1;i<=NF;i++){FS="";print " -+" $$i;FS="\n"}}'`

$(OBJDIR)/pthread.o:	$(SRCDIR)/pthread.c
$(OBJDIR)/cond.o:		$(SRCDIR)/cond.c  
$(OBJDIR)/mutex.o:		$(SRCDIR)/mutex.c 
$(OBJDIR)/sched.o:		$(SRCDIR)/sched.c 
$(OBJDIR)/queue.o:		$(SRCDIR)/queue.c 
