/******************************** SBB **********************************
**
** Project      :       Multiple-Threaded Library (MTL)
**
** Author       :       Zhang Xiangyang
**
** Date         :       November 4, 1996
**
** Version      :       1.0
**              :       Copyright (C) 1996, Zhang Xiangyang
**                
** File name    :       pthread.c
**
** Description  :
**
**      This file is part of pthread Library, which provides the thread 
**      interface compatible with POSIX 1003.4a Reference.
**
**      Report problems and direct all questions to:
**       zhangx@sebb.bel.alcatel.be
**
********************************HISTORY*********************************
**   DATE    INITIALS	COMMENTS		
**   ----    --------	--------
** 04/11/96  XZHANG     Creation for version 1 only
**
************************************************************************/

#ifndef _PTHREAD_STACK_H_INCLUDED
/*
char	* reg_names[] =
{
	"EBX", 		//0	:	00
	"ECX", 		//1	:	04
	"EDX", 		//2	:	08
	"ESI", 		//3	:	0C
	"EDI", 		//4	:	10
	"EBP", 		//5	:	14
	"EIP", 		//6	:	18 INSTRUCTION POINTER
	"ESP", 		//7	:	1C
	"ES/DS", 	//8	:	20 - 22
	"CS/FS",	//9 :	24 - 26
	"GS/SS",	//10:	28 - 2A
	"UNKNOWN",	//11:	2C
	"UNKNOWN",	//12:	30
};
*/

#define JB_BX 		0
#define JB_CX		1
#define JB_DX		2
#define JB_SI		3
#define JB_DI		4
#define JB_BP		5
#define JB_IP		6
#define JB_SP		7
#define JB_ESDS		8
#define JB_CSFS		9
#define JB_GSSS		10


void regs_set( void * );
#pragma aux reg_set =		\
	"MOV	EBX,+00H[EAX]",		\
	"MOV	ECX,+04H[EAX]",	\
	"MOV	EDX,+08H[EAX]",	\
	"MOV	ESI,+0cH[EAX]",	\
	"MOV	EDI,+10H[EAX]",	\
	"MOV	EAX,+10H[EAX]",	\
	parm [eax];

void regs_get( void * );
#pragma aux reg_get =		\
	"MOV	+00H[EAX], EBX",		\
	"MOV	+04H[EAX], ECX",	\
	"MOV	+08H[EAX], EDX",	\
	"MOV	+0CH[EAX], ESI",	\
	"MOV	+10H[EAX], EDI",	\
	"MOV	+14H[EAX], EBP",	\
	"MOV	+18H[EAX], EDI"	\
	"MOV	+1cH[EAX], ESP"	\
	parm [eax];
	
void 		pthread_set_sp(unsigned int );
#pragma aux pthread_set_sp = \
	"MOV	ESP, EAX",		\
	parm [eax];

void 		pthread_get_sp(unsigned int *);
#pragma aux pthread_get_sp =		\
	"MOV	[EAX], ESP",		\
	parm [eax];

void 		pthread_set_fp(void *);
#pragma aux pthread_set_fp =		\
	"MOV	ESP, [EAX]",			\
	"MOV	AX, DS",				\
	"MOV	SS, AX",				\
	parm [eax];

void 		pthread_get_fp(void *);
#pragma aux pthread_get_fp =		\
	"MOV	[EAX], ESP",			\
	parm [eax];
	
#define	CONTEXT_SWITCH(new_state)\
{\
  pthread_key_t	this_key;\
\
  this_key = mac_pthread_key();\
\
  SET_KERNEL_FLAG();\
  tcb[this_key].state = new_state;\
  if (setjmp(tcb[this_key].context) == 0)\
  {\
    pthread_key_t	sched_key;\
\
    sched_key = pthread_scheduler(this_key);\
    if (sched_key < 0)\
      fprintf(stderr, "scheduler error.\n");\
    tcb[sched_key].state = TCB_RUNNING;\
    mac_pthread_key() = sched_key;\
    longjmp(tcb[sched_key].context, sched_key+1);\
  }\
  else\
  {\
    CLEAR_KERNEL_FLAG();\
  }\
}

#define SET_THREAD_CONTEXT(key)\
{\
\
  SET_KERNEL_FLAG();\
  pthread_set_fp(&(tcb[key].oldsp));\
  CLEAR_KERNEL_FLAG();\
}

#define _PTHREAD_STACK_H_INCLUDED
#endif /* _PTHREAD_STACK_H_INCLUDED */
