Data types:

	pthread_attr_t
	pthread_t
	pthread_cleanup_t
	pthread_addr_t
	pthread_condattr_t
	pthread_cond_t
	pthread_mutex_t
	pthread_mutexattr_t

int pthread_attr_create			(pthread_attr_t * attr);
int pthread_attr_delete			(pthread_attr_t * attr);
int pthread_attr_getinheritsched(pthread_attr_t attr);
int pthread_attr_getprio		(pthread_attr_t attr);
int pthread_attr_getsched		(pthread_attr_t attr);
int pthread_attr_getstacksize	(pthread_attr_t attr);
int pthread_attr_setinheritsched(pthread_attr_t * attr, 
								 int inherit);
int pthread_attr_setprio		(pthread_attr_t * attr, 
								 int priority);
int pthread_attr_setsched		(pthread_attr_t * attr, 
								 int scheduler);
int pthread_attr_setstacksize	(pthread_attr_t * attr, 
								 long stacksize);

int pthread_cancel				(pthread_t * thread);
int pthread_cleanup_pop			(int execute);
int pthread_cleanup_push		(pthread_cleanup_t routine, 
								 pthread_addr_t arg);

int pthread_condattr_create		(pthread_condattr_t * attr);
int pthread_condattr_delete		(pthread_condattr_t * attr);

int pthread_cond_broadcast		(pthread_cond_t * cond);
int pthread_cond_destroy		(pthread_cond_t * cond);
int pthread_cond_init			(pthread_cond_t * cond, 
								 pthread_conattr_t attr);
int pthread_cond_signal			(pthread_cond_t * cond);
int pthread_cond_timedwait		(pthread_cond_t * cond,
								 pthread_mutex_t * mutex,
								 struct timespec * abstime);
int pthread_cond_wait			(pthread_cond_t * cond,
								 pthread_mutex_t * mutex);

int pthread_create				(pthread_t * thread
								 pthread_attr_t attr,
								 pthread_startroutine_t start_routine,
								 pthread_addr_t arg);
int pthread_delay_np			(struct timespec * interval);
int pthread_detach				(pthread_t * thread);
int pthread_exit				(pthread_addr_t * status);
int pthread_get_expiration_np	(struct timespec * delta,
								 struct timespec * abstime);
int pthread_getprio				(pthread_t * thread);
int pthread_setprio				(pthread_t * thread, int priority);
int pthread_getscheduler		(pthread_t * thread);
int pthread_getscheduler		(pthread_t * thread, int scheduler, int priority);
int pthread_getspecific			(pthread_key_t key,
								 pthread_addr_t * value);
int pthread_setspecific			(pthread_key_t key,
								 pthread_addr_t value);
int pthread_join				(pthread_t thread,
								 pthread_addr_t * status);
int pthread_keycreate			(pthread_key_t * key,
								 pthread_destructor_t * destructor);
								 
int pthread_mutexattr_create	(pthread_mutexattr_t * attr);
int pthread_mutexattr_delete	(pthread_mutexattr_t * attr);
int pthread_mutexattr_getkind_np(pthread_mutexattr_t * attr);
int pthread_mutexattr_setkind_np(pthread_mutexattr_t * attr,
								 int kind);
int pthread_mutex_destroy		(pthread_mutex_t * mutex);
int pthread_mutex_init			(pthread_mutex_t * mutex,
								 pthread_mutexattr_t attr);
int pthread_mutex_lock			(pthread_mutex_t * mutex);
int pthread_mutex_trylock		(pthread_mutex_t * mutex);
int pthread_mutex_unlock		(pthread_mutex_t * mutex);

pthread_once(pthread_once_t * once_block,
				pthread_initroutine_t init_routine);
pthread_self();

int pthread_setsyncancel		(int state);
int pthread_setcancel			(int state);
void pthread_testcancel			(void);

void pthread_lock_global_np(void);
void pthread_unlock_global_np(void);
void pthread_yield(void);
