#include <stdio.h> 
#include <stdlib.h>
#include <string.h>
#include <setjmp.h>
#include <time.h>

char 		* reg_names[] =
			{
				"EAX",
				"EBX",
				"ECX",
				"EDX",
				"EBP",
				"ESP",
				"EDI",
				"ESI",
				"CS/DS",
				"ES/FS",
				"GS/SS",
				"EFLAG",
			};
			
unsigned int	regs[] =
				{
					0x1111,
					0x2222,
					0x3333,
					0x4444,
					0x5555,
					0x6666,
					0x7777,
					0x8888,
				};
				
void reg_set( void * );
#pragma aux reg_set =		\
	"mov	ebx,[eax]",		\
	"mov	ecx,+4H[eax]",	\
	"mov	edx,+8H[eax]",	\
	"mov	esi,+0cH[eax]",	\
	"mov	edi,+10H[eax]",	\
	"mov	eax,+10H[eax]",	\
	parm [eax];


jmp_buf	env;

void main() {

	int 	i, ret_val; 
	
	ret_val = 293;
	reg_set(regs);
	printf("** size of jmp_buf: %d ****\n", sizeof(jmp_buf));
	if( (ret_val =  setjmp( env )) == 0 ) { 
		printf("after setjmp %d\n", ret_val);
		prn();
		rtn();
		printf(" back from rtn %d\n", ret_val);
	} else 
		printf(" back from long jump %d\n", ret_val);
}

prn(){

	int i;

	printf("\tContents of jump buffer\n");
	for( i=0; i<13; ++i) 
		printf("%s:\tbuf[%d] = %xH\n", reg_names[i], i, env[i]);
}
rtn() {
	printf( "about to longjmp\n" );
	longjmp( env, 14);	
}