#ifndef _PTHREAD_STACK_H_INCLUDED

char 		* reg_names[] =
			{
				"EBX", 		//0	:	00
				"ECX", 		//1	:	04
				"EDX", 		//2	:	08
				"ESI", 		//3	:	0C
				"EDI", 		//4	:	10
				"EBP", 		//5	:	14
				"EIP", 		//6	:	18 INSTRUCTION POINTER
				"ESP", 		//7	:	1C
				"ES/DS", 	//8	:	20 - 22
				"CS/FS",	//9 :	24 - 26
				"GS/SS",	//10:	28 - 2A
				"UNKNOWN",	//11:	2C
				"UNKNOWN",	//12:	30
			};


void regs_set( void * );
#pragma aux reg_set =		\
	"mov	ebx,+00H[eax]",		\
	"mov	ecx,+04H[eax]",	\
	"mov	edx,+08H[eax]",	\
	"mov	esi,+0cH[eax]",	\
	"mov	edi,+10H[eax]",	\
	"mov	eax,+10H[eax]",	\
	parm [eax];

void regs_get( void * );
#pragma aux reg_get =		\
	"mov	+00[EAX], EBX",		\
	"mov	+04H[EAX], ECX",	\
	"mov	+08H[EAX], EDX",	\
	"mov	+0CH[EAX], ESI",	\
	"mov	+10H[EAX], EDI",	\
	"mov	+14H[EAX], EBP",	\
	"mov	+18H[EAX], edi"	\
	"mov	+1cH[EAX], ESP"	\
	parm [eax];
	
void 		pthread_set_sp(unsigned int );
#pragma aux pthread_set_sp = \
	"MOV	ESP, EAX",		\
	parm [eax];

void 		pthread_get_sp(unsigned int *);
#pragma aux pthread_get_sp =		\
	"MOV	[EAX], ESP",		\
	parm [eax];

int 		pthread_get_fp();
void 		pthread_set_fp();
	

#define _PTHREAD_STACK_H_INCLUDED
#endif /* _PTHREAD_STACK_H_INCLUDED */
