#include <stdlib.h>
#include <string.h>
#include <setjmp.h>
#include <time.h>

void branch( void * );
#pragma aux branch =		\
	"push	+18H[eax]",		\
	"mov	ebx,[eax]",		\
	"mov	ecx,+4H[eax]",	\
	"mov	esi,+0cH[eax]",	\
	"mov	edi,+10H[eax]",	\
	"mov	ebp,+14H[eax]",	\
	"mov	edx,+8H[eax]",	\
	"ret"					\
	parm [eax];
/*
#pragma aux branch =	\
	"push eax",			\
	"mov eax, 1",		\
	"ret"				\
	parm [eax];
*/
int loclen( void );
#pragma aux loclen =	\
	"mov EAX, EBP",		\
	"sub EAX, ESP";

void *locaddr( void );
#pragma aux locaddr = "mov EAX, ESP";

enum { ACTIVE, ASLEEP, FINISHED };

#pragma aux cdecl frame modify [ eax ebx ecx edx esi edi ];

typedef struct {
	char stat;
	char *name;
	int inst;
	jmp_buf jbuf;
	void cdecl ( *func )( void );
	int loclen;
	void *locbuf;
	clock_t deadline;
} thread_t;

extern thread_t *Threads;
extern int nThreads, curThread;

/*
typedef struct {
	unsigned int ebx, ecx, edx, esi, edi;
	unsigned int ebp, eip, esp;
	unsigned short es, ds, cs, fs, gs, ss;
} jmp_struc;
*/

#define RESUME()												\
		{														\
		int iThread = curThread;								\
		thread_t *pThread = &Threads[ iThread ];				\
		if ( pThread -> stat == FINISHED )						\
			return;												\
		if ( !pThread -> jbuf[ 6 ] ) {							\
			pThread -> loclen = loclen();						\
			pThread -> locbuf = malloc( pThread -> loclen );	\
			pThread -> stat = ACTIVE;							\
		} else {												\
			memcpy( locaddr(),									\
				pThread -> locbuf, pThread -> loclen );			\
			branch( pThread -> jbuf );							\
		}														\
		}

#define YIELD()											\
	{													\
	int iThread = curThread;							\
	thread_t *pThread = &Threads[ iThread ];			\
	pThread -> stat = ASLEEP;							\
	memcpy( pThread -> locbuf,							\
		locaddr(), pThread -> loclen );					\
	pThread -> deadline = 0;							\
	if ( !setjmp( pThread -> jbuf ) )					\
		return;											\
	}

#define YIELD_TMO( tmo )								\
	{													\
	int iThread = curThread;							\
	thread_t *pThread = &Threads[ iThread ];			\
	pThread -> stat = ASLEEP;							\
	memcpy( pThread -> locbuf,							\
		locaddr(), pThread -> loclen );					\
	pThread -> deadline = tmo ?							\
		clock() + tmo * CLOCKS_PER_SEC : 0;				\
	if ( !setjmp( pThread -> jbuf ) )					\
		return;											\
	}

#define TMO()									\
	int iThread = curThread;					\
	( Threads[ iThread ].deadline &&			\
	Threads[ iThread ].deadline < clock() )		\

#define TERM()									\
	{											\
	int iThread = curThread;					\
	thread_t *pThread = &Threads[ iThread ];	\
	free( pThread -> locbuf );					\
	pThread -> stat = FINISHED;					\
	return;										\
	}

thread_t *init_threads(
	char *th_name, void cdecl ( *th_func )( void ), int th_ninst, ... );
void cdecl run_thread( int iThread );
